


Dim oTempFeedIni, fso, logfilehandle, f, f1, f2
Dim WshShell, objArgs, CreateFolder
Dim retvar
Dim DebugOutToggle
Dim DescriptionDetailsArray
Dim dblTimer

Const ForReading = 1, ForWriting = 2, ForAppending = 8


' Start a timer to use for logging
dblTimer = Timer()

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'' Default Values
''
''    The Default values will be used where global or
''    Channel values are not specified.
''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'possible values are 'scrollboard', 'dashboard' or (maybe) 'tipboard'
DefaultTickerDestination = "scrollboard" 
DefaultTickerDirIn = "C:\Program Files\CoolTicker\ToDo"
DefaultTickerExpireMinutes = "60"


' Mirror Folder will be created in the current script folder.
MirrorOutputFolder = "output"

'TickerDirIn = "C:\Program Files\CoolTicker\TickerIn"
TickerDirIn = DefaultTickerDirIn

' The following value is no longer used
'TempFeedFile = "C:\Program Files\Awasu\ChannelHooks\TestCopyConfig\awasu249"


Set fso = CreateObject("Scripting.FileSystemObject")
Set WshShell = WScript.CreateObject("WScript.Shell")
Set objArgs = WScript.Arguments

' Get various paths
ThisScriptName = WScript.ScriptName
ThisScriptBaseName = fso.GetBaseName(ThisScriptName)
ScriptStartTime = Now
ScriptStartTimeUTC = UDate(ScriptStartTime)
LogFile = ThisScriptBaseName & ".log"

PathScriptStart = WshShell.CurrentDirectory
MirrorOutputFolder = PathScriptStart & "\output"


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'' TempFeedFile Variable
''
''     The TempFeedFile is a control file created by
''     Awasu. The full path of the file is passed to
''     this script as the first command line argument.
''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
TempFeedFile = ""



''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'' DebugOutToggle Variable
''
''     The DebugOutToggle is a Boolean value. When set
''     to a value of 1, program information will be
''     shown at runtime in message boxes.
''
''     Set to 0 to disable debug messages.
''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''
DebugOutToggle = 0


If DebugOutToggle = 1 Then
	strDebugOut = ""
	strDebugOut = strDebugOut & "    ScriptStartTime: " & ScriptStartTime & vbCrLf
	strDebugOut = strDebugOut & " ScriptStartTimeUTC: " & ScriptStartTimeUTC & vbCrLf
	strDebugOut = strDebugOut & "            LogFile: " & LogFile & vbCrLf
	retvar = DebugOut(strDebugOut)
End if


' get command line parameters
If objArgs.Count >=1 Then
	TempFeedFile = objArgs(0)
	'DebugOutToggle = 0
End If

' Always popup an error message if there is no path specified to the control file
' This usually means that the script is being run manually.
If TempFeedFile = "" Then 
	strDebugOut = ""
	strDebugOut = strDebugOut & (" ERROR: Temp feed file not specified" & vbCRLF)
	strDebugOut = strDebugOut & vbCRLF
	strDebugOut = strDebugOut & (" PathScriptStart: " & PathScriptStart & vbCRLF)
	strDebugOut = strDebugOut & ("CurrentDirectory: " & WshShell.CurrentDirectory & vbCRLF)
	'retvar = DebugOut(strDebugOut)
	MsgBox strDebugOut
	ExitScript
End If

' Create a new object from the custom INI class
Set oTempFeedIni = new ini

oTempFeedIni.FileName = TempFeedFile


''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''
'' Reading: Config
''    From Awasu control file
''''''''''''''''''''''''''''''''''''''''''''''''''''''

oTempFeedIni.Section = "Config"

hChannelCookie = ""
oTempFeedIni.Key = "hChannelCookie"
hChannelCookie = oTempFeedIni.Value
If hChannelCookie = "" Then hChannelCookie = ScriptStartTimeUTC

hChannelHookCookie = ""
oTempFeedIni.Key = "hChannelHookCookie"
hChannelHookCookie = oTempFeedIni.Value
If hChannelHookCookie = "" Then hChannelHookCookie = ScriptStartTimeUTC

LocalChannelId = ""
oTempFeedIni.Key = "LocalChannelId"
LocalChannelId = oTempFeedIni.Value
If Not IsNumeric(LocalChannelId) Or LocalChannelId = "" Then LocalChannelId = 0

	
ChannelConfigFile = ""
oTempFeedIni.Key = "ChannelConfigFile"
ChannelConfigFile = oTempFeedIni.Value




''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''
'' Reading: GlobalChannelHookParameters
''    From Awasu control file
''''''''''''''''''''''''''''''''''''''''''''''''''''''

oTempFeedIni.Section = "GlobalChannelHookParameters"

GlobalExpireMinutes = ""
oTempFeedIni.Key = "GlobalExpireMinutes"
GlobalExpireMinutes = oTempFeedIni.Value
If Not IsNumeric(GlobalExpireMinutes) Then GlobalExpireMinutes = -1
	
GlobalMaxItemsPerRun = ""
oTempFeedIni.Key = "GlobalMaxItemsPerRun"
GlobalMaxItemsPerRun = oTempFeedIni.Value

GlobalTickerInboxPath = ""
oTempFeedIni.Key = "GlobalTickerInboxPath"
GlobalTickerInboxPath = oTempFeedIni.Value

GlobalEnableLogging = ""
oTempFeedIni.Key = "GlobalEnableLogging"
GlobalEnableLogging = oTempFeedIni.Value
If GlobalEnableLogging = "" Then GlobalEnableLogging = "0"

GlobalDisableThisHook = "0"
oTempFeedIni.Key = "GlobalDisableThisHook"
GlobalDisableThisHook = oTempFeedIni.Value
If GlobalDisableThisHook = "" Then GlobalDisableThisHook = "0"


GlobalEnableMirrorOutput = ""
oTempFeedIni.Key = "GlobalEnableMirrorOutput"
GlobalEnableMirrorOutput = oTempFeedIni.Value
If GlobalEnableMirrorOutput = "" Then GlobalEnableMirrorOutput = "0"

GlobalTickerDestination = ""
oTempFeedIni.Key = "GlobalTickerDestination"
GlobalTickerDestination = oTempFeedIni.Value
'If GlobalTickerDestination = "" Then GlobalTickerDestination = "scrollboard"
'If GlobalTickerDestination = "" Then GlobalTickerDestination = "dashboard"
'If GlobalTickerDestination = "" Then GlobalTickerDestination = "tipboard"



If DebugOutToggle = 1 Then
	strDebugOut = "" & vbCrLf
	strDebugOut = strDebugOut & "Parsing Control File Section: " & oTempFeedIni.Section & vbCrLf
	strDebugOut = strDebugOut & vbCrLf
	strDebugOut = strDebugOut & vbTab & "GlobalExpireMinutes: " & GlobalExpireMinutes & vbCrLf
	strDebugOut = strDebugOut & vbTab & "GlobalMaxItemsPerRun: " & GlobalMaxItemsPerRun & vbCrLf
	strDebugOut = strDebugOut & vbTab & "GlobalTickerInboxPath: " & GlobalTickerInboxPath & vbCrLf
	strDebugOut = strDebugOut & vbTab & "GlobalEnableLogging: " & GlobalEnableLogging & vbCrLf
	strDebugOut = strDebugOut & vbTab & "GlobalEnableMirrorOutput: " & GlobalEnableLogging & vbCrLf
	strDebugOut = strDebugOut & vbTab & "GlobalTickerDestination: " & GlobalTickerDestination & vbCrLf
	retvar = DebugOut(strDebugOut)
End if




''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''
'' Reading: ChannelHookParameters
''    From Awasu control file
''''''''''''''''''''''''''''''''''''''''''''''''''''''

oTempFeedIni.Section = "ChannelHookParameters"

ChannelShortName = ""
oTempFeedIni.Key = "ShortName"
ChannelShortName = oTempFeedIni.Value

ChannelExpireMinutes = ""
oTempFeedIni.Key = "ExpireMinutes"
ChannelExpireMinutes = oTempFeedIni.Value
If Not IsNumeric(ChannelExpireMinutes) Then ChannelExpireMinutes = -1

ChannelMaxItemsPerRun = ""
oTempFeedIni.Key = "MaxItemsPerRun"
ChannelMaxItemsPerRun = oTempFeedIni.Value

ChannelForegroundColor = ""
oTempFeedIni.Key = "ForegroundColor"
ChannelForegroundColor = oTempFeedIni.Value

ChannelBackgroundColor = ""
oTempFeedIni.Key = "BackgroundColor"
ChannelBackgroundColor = oTempFeedIni.Value

ChannelDescriptionColor = ""
oTempFeedIni.Key = "DescriptionColor"
ChannelDescriptionColor = oTempFeedIni.Value

ChannelDisableThisHook = ""
oTempFeedIni.Key = "DisableThisHook"
ChannelDisableThisHook = oTempFeedIni.Value

ChannelTickerDestination = ""
oTempFeedIni.Key = "TickerDestination"
ChannelTickerDestination = oTempFeedIni.Value

ChannelEnableLogging = ""
oTempFeedIni.Key = "EnableLogging"
ChannelEnableLogging = oTempFeedIni.Value
If ChannelEnableLogging = "" Then ChannelEnableLogging = "0"
	
ChannelEnableMirrorOutput = ""
oTempFeedIni.Key = "EnableMirrorOutput"
ChannelEnableMirrorOutput= oTempFeedIni.Value


If DebugOutToggle = 1 Then
	strDebugOut = "" & vbCrLf
	strDebugOut = strDebugOut & "Parsing Control File Section: " & oTempFeedIni.Section & vbCrLf
	strDebugOut = strDebugOut & vbCrLf
	strDebugOut = strDebugOut & vbTab & "ChannelExpireMinutes: " & ChannelExpireMinutes & vbCrLf
	strDebugOut = strDebugOut & vbTab & "ChannelMaxItemsPerRun: " & ChannelMaxItemsPerRun & vbCrLf
	strDebugOut = strDebugOut & vbTab & "ChannelForegroundColor: " & ChannelForegroundColor & vbCrLf
	strDebugOut = strDebugOut & vbTab & "ChannelBackgroundColor: " & ChannelBackgroundColor & vbCrLf
	strDebugOut = strDebugOut & vbTab & "ChannelDisableThisHook: " & ChannelDisableThisHook & vbCrLf
	strDebugOut = strDebugOut & vbTab & "ChannelTickerDestination: " & ChannelTickerDestination & vbCrLf
	retvar = DebugOut(strDebugOut)
End if


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'' Logging
''   - Config files loaded so logging can be started now.
''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
WriteLog "Script Started: " & ScriptStartTime

strWriteLog = ""
strWriteLog = strWriteLog & "hChannelCookie=" & hChannelCookie
strWriteLog = strWriteLog & ", hChannelHookCookie=" & hChannelHookCookie 
strWriteLog = strWriteLog & ", LocalChannelId=" & LocalChannelId
strWriteLog = strWriteLog & ", ChannelConfigFile=" & ChannelConfigFile
WriteLog strWriteLog

strWriteLog = ""
strWriteLog = strWriteLog & "GlobalExpireMinutes=" & GlobalExpireMinutes
strWriteLog = strWriteLog & ", GlobalMaxItemsPerRun=" & GlobalMaxItemsPerRun 
strWriteLog = strWriteLog & ", GlobalTickerInboxPath=" & GlobalTickerInboxPath
strWriteLog = strWriteLog & ", GlobalEnableLogging=" & GlobalEnableLogging
strWriteLog = strWriteLog & ", GlobalEnableMirrorOutput=" & GlobalEnableLogging
strWriteLog = strWriteLog & ", GlobalTickerDestination=" & GlobalTickerDestination
WriteLog strWriteLog

strWriteLog = ""
strWriteLog = strWriteLog & "ChannelExpireMinutes=" & ChannelExpireMinutes
strWriteLog = strWriteLog & ", ChannelMaxItemsPerRun=" & ChannelMaxItemsPerRun 
strWriteLog = strWriteLog & ", ChannelForegroundColor=" & ChannelForegroundColor
strWriteLog = strWriteLog & ", ChannelBackgroundColor=" & ChannelBackgroundColor
strWriteLog = strWriteLog & ", ChannelDisableThisHook=" & ChannelDisableThisHook
strWriteLog = strWriteLog & ", ChannelTickerDestination=" & ChannelTickerDestination
WriteLog strWriteLog



''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'' Resolve Global and Channel Parameters
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


If GlobalEnableMirrorOutput = "" Then GlobalEnableMirrorOutput = "0"
If ChannelEnableMirrorOutput = "" Then ChannelEnableMirrorOutput = "0"
If GlobalEnableMirrorOutput = "1" Or ChannelEnableMirrorOutput = "1" Then
	If Not (fso.FolderExists(MirrorOutputFolder)) Then
		Set CreateFolder = fso.CreateFolder(MirrorOutputFolder)
		Set f = nothing
  End If
 fso.CopyFile TempFeedFile, MirrorOutputFolder & "\" & ScriptStartTimeUTC & "_TempChannelFeed.ini"
End If



If ChannelDisableThisHook = "1" Or GlobalDisableThisHook = "1" Then 
	WriteLog "Script has been disabled by control parameter. Exiting script..."
	ExitScript
End If

ExpireMinutes = DefaultTickerExpireMinutes
If ChannelExpireMinutes > -1 Then
	ExpireMinutes = ChannelExpireMinutes
ElseIf ChannelExpireMinutes > -1 Then
	ExpireMinutes = GlobalExpireMinutes
End If

ExpireMinutesOut = "60 Minutes (1 H)"
If ExpireMinutes > 0 And ExpireMinutes <= 6 Then ExpireMinutesOut = "5 Minutes"
If ExpireMinutes > 6 And ExpireMinutes <= 11 Then ExpireMinutesOut = "10 Minutes"
If ExpireMinutes > 11 And ExpireMinutes <= 16 Then ExpireMinutesOut = "15 Minutes"
If ExpireMinutes > 16 And ExpireMinutes <= 21 Then ExpireMinutesOut = "20 Minutes"
If ExpireMinutes > 21 And ExpireMinutes <= 31 Then ExpireMinutesOut = "30 Minutes"
If ExpireMinutes > 31 And ExpireMinutes <= 46 Then ExpireMinutesOut = "45 Minutes"
If ExpireMinutes > 46 And ExpireMinutes <= 61 Then ExpireMinutesOut = "60 Minutes (1 H)"
If ExpireMinutes > 61 And ExpireMinutes <= 121 Then ExpireMinutesOut = "120 Minutes (2 H)"
If ExpireMinutes > 121 And ExpireMinutes <= 181 Then ExpireMinutesOut = "180 Minutes (3 H)"
If ExpireMinutes > 181 And ExpireMinutes <= 241 Then ExpireMinutesOut = "240 Minutes (4 H)"
If ExpireMinutes > 241 And ExpireMinutes <= 300 Then ExpireMinutesOut = "300 Minutes (5 H)"
If ExpireMinutes > 300 And ExpireMinutes <= 361 Then ExpireMinutesOut = "360 Minutes (6 H)"
If ExpireMinutes > 361 And ExpireMinutes <= 401 Then ExpireMinutesOut = "400 Minutes (7 H)"
If ExpireMinutes > 401 Then ExpireMinutesOut = "460 Minutes (8 H)"

TickerDestinationOut = DefaultTickerDestination
If ChannelTickerDestination <> "" Then
	TickerDestinationOut =	ChannelTickerDestination
ElseIf GlobalTickerDestination <> "" Then
	TickerDestinationOut =	GlobalTickerDestination
End If

'Use the default colors set in CoolTicker if none is specified
ForegroundColorOut = FormatTickerColor(ChannelForegroundColor)
WriteLog "ForegroundColorOut=" & ForegroundColorOut

BackgroundColorOut = FormatTickerColor(ChannelBackgroundColor)
WriteLog "BackgroundColorOut=" & BackgroundColorOut

DescriptionColorOut = FormatTickerColor(ChannelDescriptionColor)
WriteLog "DescriptionColorOut=" & DescriptionColorOut

If ForegroundColorOut <> "" Or BackgroundColorOut <> "" Or DescriptionColorOut <> "" Then
	If ForegroundColorOut = "" Or BackgroundColorOut = "" Or DescriptionColorOut = "" Then
		WriteLog "WARNING: Colors will not be used. All colors parameters must have values or none are used."
	End If
End If



TickerDirIn = DefaultTickerDirIn
If GlobalTickerInboxPath <> "" And fso.FolderExists(GlobalTickerInboxPath) Then TickerDirIn = GlobalTickerInboxPath
WriteLog "Using Ticket Inbox: " & TickerDirIn


ShortNameOut = ""
If ChannelShortName <> "" Then
	ShortNameOut = Trim(ChannelShortName)
	ShortNameOut = Mid(ShortNameOut,1,10) & ": "
End If


'If GlobalEnableLogging = "1" Then
'	Set logfilehandle = fso.OpenTextFile(LogFile, 8, True)
'End If


FeedItemCount = 0
LastFeedItem = False
LastFeedItem = 0
LastFeedItemNumber = 0
strAllTicketsOut = ""

Do While Not LastFeedItem
	FeedItemNumber = FeedItemNumber + 1
	oTempFeedIni.Section = "NewFeedItem-" & FeedItemNumber 

	oTempFeedIni.Key = "ItemId"
	FeedItemId = oTempFeedIni.Value
	'
	If FeedItemId = "" Then
		LastFeedItem = True
		Exit Do
	End If

	'MsgBox oTempFeedIni.Value
	
	oTempFeedIni.Key = "ExternalItemId"
	FeedExternalItemId=oTempFeedIni.Value
	'http://www.democraticunderground.com/discuss/duboard.php?az=view_all&address=104x5280903

	oTempFeedIni.Key = "ItemTitle"
	FeedItemTitle=oTempFeedIni.Value
	'Know your BFEE: Bush and bin Laden Clans Together in Bed

	oTempFeedIni.Key = "ItemUrl"
	FeedItemUrl=oTempFeedIni.Value
	'http://www.democraticunderground.com/discuss/duboard.php?az=view_all&address=104x5280903

	oTempFeedIni.Key = "TimeCreated"
	FeedTimeCreated=oTempFeedIni.Value
	'1131321778

	oTempFeedIni.Key = "ItemFingerprint"
	FeedItemFingerprint=oTempFeedIni.Value
	'28d20818f0de8e9bbab497d20c6dd950

	oTempFeedIni.Key = "ItemMetadata"
	FeedItemMetadata=oTempFeedIni.Value
	'

	oTempFeedIni.Key = "ItemLink1_Uri"
	FeedItemLink1_Uri=oTempFeedIni.Value
	'http://www.democraticunderground.com/discuss/duboard.php?az=view_all&address=104x5280903

	oTempFeedIni.Key = "ItemLink1_RelType"
	FeedItemLink1_RelType=oTempFeedIni.Value
	'

	oTempFeedIni.Key = "FeedItemLink1_Title"
	FeedItemLink1_Title=oTempFeedIni.Value
	'

	oTempFeedIni.Key = "ItemLink1_MediaType"
	FeedItemLink1_MediaType=oTempFeedIni.Value
	'

	oTempFeedIni.Key = "ItemLink1_Size"
	FeedItemLink1_Size=oTempFeedIni.Value
	'0

	oTempFeedIni.Key = "ItemLink2_Uri"
	FeedItemLink2_Uri=oTempFeedIni.Value
	'http://www.democraticunderground.com/discuss/duboard.php?az=view_all&address=104x5280903

	oTempFeedIni.Key = "ItemLink2_RelType"
	FeedItemLink2_RelType=oTempFeedIni.Value
	'_permalink

	oTempFeedIni.Key = "ItemLink2_Title"
	FeedItemLink2_Title=oTempFeedIni.Value
	'

	oTempFeedIni.Key = "ItemLink2_MediaType"
	FeedItemLink2_MediaType=oTempFeedIni.Value
	'

	oTempFeedIni.Key = "ItemLink2_Size"
	FeedItemLink2_Size=oTempFeedIni.Value
	'0

	oTempFeedIni.Key = "ItemContent1_MediaType"
	FeedItemContent1_MediaType=oTempFeedIni.Value
	'

	oTempFeedIni.Key = "ItemContent1_LanguageTag"
	FeedItemContent1_LanguageTag=oTempFeedIni.Value
	'

	oTempFeedIni.Key = "ItemContent1_Content"
	FeedItemContent1_Content=oTempFeedIni.Value
	'20 recommendations : By Octafish%0A

	oTempFeedIni.Key = "MarkedUpDescription"
	FeedMarkedUpDescription=oTempFeedIni.Value
	'20 recommendations : By Octafish%0A

	oTempFeedIni.Key = "PlainTextDescription"
	FeedPlainTextDescription=oTempFeedIni.Value
	'20 recommendations : By Octafish%0A

	strTicketOut = ""
	strTicketOut = strTicketOut & "ticker_start=" & FeedItemId & vbCrLf
	strTicketOut = strTicketOut & "ticker_title=" & FixSpecialChars(URLDecode(Mid(RemoveHTML(FeedItemTitle),1,128))) & vbCrLf
	strTicketOut = strTicketOut & "ticker_text=" & ShortNameOut & FixSpecialChars(URLDecode(Mid(RemoveHTML(FeedPlainTextDescription),1,128))) & vbCrLf
	strTicketOut = strTicketOut & "ticker_dest=" & TickerDestinationOut & vbCrLf
	strTicketOut = strTicketOut & "ticker_instant_url=" & FeedItemLink1_Uri & vbCrLf
	'strTicketOut = strTicketOut & "ticker_expire_at=" & vbCrLf
	'Format: 11/7/2005 7:45:26 AM
	'strTicketOut = strTicketOut & "ticker_expire_in=60 Minutes (1 H)" & vbCrLf

	If ExpireMinutes <> 0 Then strTicketOut = strTicketOut & "ticker_expire_in=" & ExpireMinutesOut & vbCrLf

	''
	'' All Colors are required.
	''
	If BackgroundColorOut <> "" And ForegroundColorOut <> "" And DescriptionColorOut <> "" Then 
	'If BackgroundColorOut <> "" Then 
		strTicketOut = strTicketOut & "ticker_color_background=" & BackgroundColorOut & vbCrLf
	'End If

	'If ForegroundColorOut <> "" Then 	
		strTicketOut = strTicketOut & "ticker_color_title=" & ForegroundColorOut & vbCrLf
		'strTicketOut = strTicketOut & "ticker_color_title=$C08080" & vbCrLf
	'End If

	'If DescriptionColorOut <> "" Then 	
		strTicketOut = strTicketOut & "ticker_color_text=" & DescriptionColorOut & vbCrLf
		'strTicketOut = strTicketOut & "ticker_color_text=$808080" & vbCrLf
	'End If

	'If ForegroundColorOut <> "" Then 	
		strTicketOut = strTicketOut & "ticker_color_separator=" & ForegroundColorOut & vbCrLf
		'strTicketOut = strTicketOut & "ticker_color_separator=$000000" & vbCrLf
	End If


	strTicketOut = strTicketOut & "ticker_color_profile=" & vbCrLf
	'strTicketOut = strTicketOut & "ticker_start=FeedItemId" & vbCrLf
	strTicketOut = strTicketOut & "ticker_icon_number=0" & vbCrLf
	strTicketOut = strTicketOut & "ticker_stop=" & FeedItemId & vbCrLf

	WriteLog "Ticket #" & FeedItemNumber & ": ID=" & FeedItemId & ": Begin Writing Ticket"
	
	Set f = fso.OpenTextFile(TickerDirIn & "\" & FeedItemId + ".txt", ForWriting, True)
	f.Write strTicketOut
	f.Close
	Set f = nothing

	WriteLog "Ticket #" & FeedItemNumber & ": ID=" & FeedItemId & ": Finished Writing Ticket"
	

	If GlobalEnableMirrorOutput = "1" Then
		Set f2 = fso.OpenTextFile(MirrorOutputFolder & "\" & ScriptStartTimeUTC & "_ticket_" & FeedItemId & ".txt", ForWriting, True)
		f2.Write strTicketOut
		f2.Close
		Set f2 = nothing
		WriteLog "Ticket #" & FeedItemNumber & ": ID=" & FeedItemId & ": Ticket Mirrored to Output Folder"
	End If

	strAllTicketsOut = strAllTicketsOut & strTicketOut
	
Loop

If GlobalEnableMirrorOutput = "1" Then
	Set f2 = fso.OpenTextFile(MirrorOutputFolder & "\" & ScriptStartTimeUTC & "_alltickets" & ".txt", ForWriting, True)
	f2.Write strAllTicketsOut
	f2.Close
	Set f2 = nothing
	WriteLog "Combined Tickets File Mirrored to Output Folder"
End If



WriteLog "Finished Processing Tickets"


'MsgBox UnUdate(Udate(Now))
'MsgBox URLDecode("Octafish%0A")
'MsgBox URLEncode(URLDecode("Octafish%0A"))


'If GlobalEnableLogging = "1" Then
'	logfilehandle.Close
'	Set logfilehandle = nothing
'End If

Set oTempFeedIni = nothing

'MsgBox "Create Tickers Complete."

ExitScript




'
' Function to convert HTML color to CoolTicker Color format
'
Function FormatTickerColor( strColorIn )

	strColorOut = ""

	If Left(strColorIn,1) = "$" And Len(strColorIn) = 7 Then
		strColorOut = strColorIn

	ElseIf strColorIn <> "" And Len(strColorIn) >= 6 Then
		tmpHTMLColor = ""
		tmpHTMLColorBlue = ""
		tmpHTMLColorGreen = ""
		tmpHTMLColorRed = ""

		If Left(strColorIn,1) = "#" And Len(strColorIn) = 7 Then
			tmpHTMLColor = UCase(Replace(Trim(strColorIn),"#","",1,-1,1))
		ElseIf Len(strColorIn) = 6 And Not InStr(1,strColorIn,"#",1) And Not InStr(1,strColorIn,"$",1) Then
			tmpHTMLColor = UCase(strColorIn)
		End If

	  If tmpHTMLColor <> "" And Len(tmpHTMLColor) = 6 Then
  		tmpHTMLColorBlue = Mid(tmpHTMLColor,1,2)
	  	tmpHTMLColorGreen = Mid(tmpHTMLColor,3,2)
  		tmpHTMLColorRed = Mid(tmpHTMLColor,5,2)
  		strColorOut = "$" & tmpHTMLColorRed & tmpHTMLColorGreen & tmpHTMLColorBlue
  	End If

	End If

FormatTickerColor = strColorOut

End Function






Function WriteLog( strText )
	If GlobalEnableLogging = "1" Or ChannelEnableLogging = "1" Then
		Set logfilehandle = fso.OpenTextFile(LogFile, 8, True)
		If LocalChannelId < 9 Then 
			strChannelId = "00" & LocalChannelId
		ElseIf LocalChannelId < 99 And LocalChannelId > 9 Then
			strChannelId = "00" & LocalChannelId
		Else
			strChannelId = LocalChannelId
		End If
		logfilehandle.WriteLine "CH" & strChannelId & " - " & PrintTimer(dblTimer) & " " & strText
		logfilehandle.Close
		Set logfilehandle = nothing
	End If
End Function


Function RemoveHTML( strText )
	Dim RegEx

	'strText = Replace(strText, "<br>"," ",1,-1,1)
  'strText = Replace(strText, "<p>"," ",1,-1,1)
  'strText = Replace(strText, "</p>"," ",1,-1,1)

	Set RegEx = New RegExp

	RegEx.Pattern = "<[^>]*>"
	RegEx.Global = True

	RemoveHTML = RegEx.Replace(strText, " ")
	
	Do While InStr(1,RemoveHTML,"  ",1) > 0
		RemoveHTML = Replace(RemoveHTML, "  "," ",1,-1,1)
	Loop
	
	
End Function


Function FixSpecialChars(strText)

	TestLine_replaced = strText
	TestLine_replaced = Replace(TestLine_replaced, Chr(226)&Chr(128)&Chr(156),"""",1,-1,1)
	TestLine_replaced = Replace(TestLine_replaced, Chr(226)&Chr(128)&Chr(157),"""",1,-1,1)
	TestLine_replaced = Replace(TestLine_replaced, Chr(226)&Chr(128)&Chr(154),",",1,-1,1)
	TestLine_replaced = Replace(TestLine_replaced, Chr(226)&Chr(128)&Chr(158),",,",1,-1,1)
	TestLine_replaced = Replace(TestLine_replaced, Chr(226)&Chr(128)&Chr(166),"...",1,-1,1)
	TestLine_replaced = Replace(TestLine_replaced, Chr(226)&Chr(128)&Chr(152),"'",1,-1,1)
	TestLine_replaced = Replace(TestLine_replaced, Chr(226)&Chr(128)&Chr(153),"'",1,-1,1)


	TestLine_replaced = Replace(TestLine_replaced, Chr(226)&Chr(128)&Chr(147),"-",1,-1,1)
	TestLine_replaced = Replace(TestLine_replaced, Chr(226)&Chr(128)&Chr(148),"-",1,-1,1)
	TestLine_replaced = Replace(TestLine_replaced, "  "," ",1,-1,1)
	'TestLine_replaced = Replace(TestLine_replaced, Chr(226)&Chr(128)&Chr(186),"*",1,-1,1)
	'TestLine_replaced = Replace(TestLine_replaced, Chr(226)&Chr(128)&Chr(153),"'",1,-1,1)
	'TestLine_replaced = Replace(TestLine_replaced, Chr(226)&Chr(128)&Chr(153),"'",1,-1,1)


	'32-126

	TestLine_removed = ""

	For TextCounter = 1 to Len(TestLine_replaced)
		TestChar = ""
		TestChar = Mid(TestLine_replaced,TextCounter,1)
		If Asc(TestChar) >= 32 And Asc(TestChar) <= 126 Then TestLine_removed = TestLine_removed & TestChar

	Next

	FixSpecialChars = TestLine_removed

End Function





Function URLEncode(sRawURL)

    'On Error Goto Catch
    iLoop = 0
    sRtn = ""
    sTmp = ""
    sValidChars = "1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz:/.?=_-$(){}~&"


    If Len(sRawURL) > 0 Then
        ' Loop through each char


        For iLoop = 1 To Len(sRawURL)
            sTmp = Mid(sRawURL, iLoop, 1)


            If InStr(1, sValidChars, sTmp, vbBinaryCompare) = 0 Then
                ' If not ValidChar, convert to HEX and p
                '     refix with %
                sTmp = Hex(Asc(sTmp))


                If sTmp = "20" Then
                    sTmp = "+"
                ElseIf Len(sTmp) = 1 Then
                    sTmp = "%0" & sTmp
                Else
                    sTmp = "%" & sTmp
                End If
            End If
            sRtn = sRtn & sTmp
        Next 
        URLEncode = sRtn
    End If
    'Finally:
    'Exit Function
    'Catch:
    'URLEncode = ""
    'Resume Finally
End Function




Function URLDecode(sEncodedURL)
    'On Error Goto Catch
    
    iLoop = 0
    sRtn = ""
    sTmp = ""
    URLDecode = ""


    If Len(sEncodedURL) > 0 Then
        ' Loop through each char


        For iLoop = 1 To Len(sEncodedURL)
            sTmp = Mid(sEncodedURL, iLoop, 1)
            sTmp = Replace(sTmp, "+", " ")
            ' If char is % then get next two chars
            ' and convert from HEX to decimal


            If sTmp = "%" and LEN(sEncodedURL) + 1 > iLoop + 2 Then
                sTmp = Mid(sEncodedURL, iLoop + 1, 2)
                sTmp = Chr(CDbl("&H" & sTmp))
                ' Increment loop by 2
                iLoop = iLoop + 2
            End If
            sRtn = sRtn & sTmp
        Next 
        URLDecode = sRtn
    End If

    'Finally:
    'Exit Function
    'Catch:
    'URLDecode = ""
    'Resume Finally
End Function





function UDate(oldDate)
  UDate = DateDiff("s", "01/01/1970 00:00:00", oldDate)
end function

function unUDate(intTimeStamp)
  unUDate = DateAdd("s", intTimeStamp, "01/01/1970 00:00:00")
end function


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Millisecond Timer
'
' From : http://authors.aspalliance.com/mamanze/articles/?p=vbscripttimer
'
'	Example Usage:
'	
' 		Dim dblTimer 
'   
'	 		dblTimer = Timer() 
'  
' 		For i=0 to 100000 
' 		Next 
'   
' 		Response.Write PrintTimer(dblTimer) 
'
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function PrintTimer(byVal dblTimer) 
' Developed by Ryan Trudelle-Schwarz for www.mamanze.com  
   
' This is a wrapper function for the PrintInterval function. Use  
' this function if you want to check for the midnight rollover.  
   
  Dim dblTimer2 
   
' Grab the end time.  
  dblTimer2 = Timer() 
   
' Check for the midnight rollover.  
  If dblTimer2 < dblTimer Then 
    dblTimer2 = dblTimer2 + 86400 
  End If 
   
' Call the function that will give us a pretty result.  
  PrintTimer = PrintInterval(dblTimer2 - dblTimer) 
End Function 
   
Function PrintInterval(byVal dblMilliSecond) 
' Developed by Ryan Trudelle-Schwarz for www.mamanze.com  
  Dim intMilliSecond, intSecond, intMinute, intHour 
  Dim strReturn 
   
  strReturn =""   
   
' Determine the number of milliseconds.  
  intMilliSecond = Int(dblMilliSecond*1000) mod 1000 
   
' Determine the number of seconds. This is not the second value  
' yet, just the number of seconds.  
  intSecond = Int(dblMilliSecond) 
   
' Determine the number of minutes, simply divide the total number  
' of seconds by 60 and get the real number result.  
  intMinute = Int(intSecond / 60) 
   
' Now we modulus the seconds by 60 to form the seconds value.  
  intSecond = intSecond mod 60 
   
' Compute the Hours value by dividing the minutes by 60.  
  intHour = Int(intMinute / 60) 
   
' Compute the actual minute value by getting the modulus of the  
' total number of minutes and 60.  
  intMinute = intMinute mod 60 

	strReturn = ""
	If intHour < 10 Then 
		strReturn = strReturn & "0" & intHour
	Else
		strReturn = strReturn & intHour
	End If

	If intMinute < 10 Then 
		strReturn = strReturn & ":0" & intMinute
	Else
		strReturn = strReturn & ":" & intMinute
	End If

	If intSecond < 10 Then 
		strReturn = strReturn & ":0" & intSecond
	Else
		strReturn = strReturn & ":" & intSecond
	End If

	If intMilliSecond < 1000 And intMilliSecond > 99 Then 
		strReturn = strReturn & ":0" & intMilliSecond
	ElseIf intMilliSecond < 100 And intMilliSecond > 9 Then 
		strReturn = strReturn & ":00" & intMilliSecond
	ElseIf intMilliSecond < 9 Then 
		strReturn = strReturn & ":000" & intMilliSecond
	Else
		strReturn = strReturn & ":" & intMilliSecond
	End If


' If the timer took more then a hour then display the hours.  
'  If intHour > 0 Then 
'    If intHour = 1 Then 
'      strReturn = strReturn & intHour &" Hour "   
'    Else 
'      strReturn = strReturn & intHour &" Hours "   
'    End If 
'  End If 
   
' If the timer took more then a minute then display the minutes.  
'  If intMinute > 0 Then 
'    If intMinute = 1 Then 
'      strReturn = strReturn & intMinute &" Minute "   
'    Else 
'      strReturn = strReturn & intMinute &" Minutes "   
'    End If 
'  End If 
   
' If the timer took more then a second then display the seconds.  
'  If intSecond > 0 Then 
'    If intSecond = 1 Then 
'      strReturn = strReturn & intSecond &" Second "   
'    Else 
'      strReturn = strReturn & intSecond &" Seconds "   
'    End If 
'  End If 
   
' If the timer took more then a millisecond then display the  
' milliseconds. Also, if the script took no time then display 0  
' milliseconds.  
   
'  If strReturn ="" OR intMilliSecond > 0 Then 
'    If intMilliSecond = 1 Then 
'      strReturn = strReturn & intMilliSecond &" MilliSecond"   
'    Else 
'      strReturn = strReturn & intMilliSecond &" MilliSeconds"   
'    End If 
'  End If 
   
  PrintInterval = strReturn 
End Function 


' from http://www.interclasse.com/scripts/class_ini.php

'Class for Ini
'
'A generic class to access ini files
'Just put thi class in your scripts and use it like this :
'
'Dim x 
'set x=new ini 
'x.FileName="C:\WINDOWS\Bureau\ini\wanadoo.ini" 
'x.Section="icone0" 
'x.Key="Id" 
'MsgBox x.Value 
'x.Key="TestKey" 
'x.Value="TestValue" 
'MsgBox x.Value 
'Set x=Nothing 

'File Name : class_ini.vbs
'Requirement : WSH 5.1
'Author : Jean-Luc Antoine
'Submitted : 26/08/2001
'Category : Class

'To use a class, follow this syntax :
'Dim MyObjClass
'set MyObjClass=new MyClass
'MyObjClass.Property="Any value"
'MsgBox MyObjClass.AnotherProperty
'MyObjClass.MyMethod MyParam1,MyParam2
'Set MyObjClass=Nothing
'Very simple, no need to rename any variable nor register any ActiveX.
Class Ini

	Private fso,f

	Public Filename	'Path to the ini File
	Public Section	'[section]
	Public Key	'Key=Value
	Public Default	'Return it when an error occurs

	Private Sub Class_Initialize   ' Setup Initialize event.
		Default=""
		Set fso=CreateObject("Scripting.FileSystemObject")
	End Sub
	Private Sub Class_Terminate   ' Setup Terminate event.
		Set fso=Nothing
	End Sub

	Property Get Content()
		'All the file in a string
		If fso.FileExists(FileName) Then
			Set f=fso.OpenTextFile(FileName,1)
			Content=f.ReadAll
			f.close
			Set f=Nothing
		Else
			Content=""
		End If
	End Property
	Property Let Content(sContent)
		'Create a brand new ini file
		Set f=fso.CreateTextFile(FileName,True)
		f.Write sContent
		f.close
		Set f=Nothing
	End Property

	Property Get ContentArray()
		'All the file in an array of lines
		ContentArray=Split(Content,vbCrLf,-1,1)
	End Property

	Private Sub FindSection(ByRef StartLine, ByRef EndLine)
		Dim x,A,s
		StartLine=-1
		EndLine=-2
		A=ContentArray
		For x=0 To UBound(A)
			s=UCase(Trim(A(x)))
			If s="[" & UCase(section) & "]" Then
				StartLine=x
			Else
				If (Left(s,1)="[") And (Right(s,1)="]") Then
					If StartLine>=0 Then
						EndLine=x-1
						If EndLine>0 Then 'A Space before the next section ?
							If Trim(A(EndLine))="" Then EndLine=EndLine-1
						End If
						Exit Sub
					End If
				End If
			End If
		Next
		If (StartLine>0) And (EndLine<0) Then EndLine=UBound(A)
	End Sub

	Property Get Value()
		'Retrieve the value for the current key in the current section
		Dim x,i,j,A,s
		FindSection i,j
		A=ContentArray
		Value=Default
		'Search only in the good section
		For x=i+1 To j
			s=Trim(A(x))
			If UCase(Left(s,Len(Key)))=UCase(Key) Then
				Select Case Mid(s,Len(Key)+1,1)
				Case "="
					Value=Trim(Mid(s,Len(Key)+2))
					Exit Property
				Case " ",chr(9)
					x=Instr(Len(Key),s,"=")
					Value=Trim(Mid(s,x+1))
					Exit Property
				End Select
			End If
		Next
	End Property
	Property Let Value(sValue)
		' Write the value for a key in a section
		Dim i,j,A,x,s,f
		FindSection i,j
		If i<0 Then 'Session doesn't exist
			Content=Content & vbCrLf & "[" & section & "]" & vbCrLf & Key & "=" & sValue
		Else
			A=ContentArray
			f=-1
			'Search for the key, either the key exists or not
			For x=i+1 To j
				s=Trim(A(x))
				If UCase(Left(s,Len(Key)))=UCase(Key) Then
					Select Case Mid(s,Len(Key)+1,1)
					Case " ",chr(9),"="
						f=x	'Key found
						A(x)=Key & "=" & sValue
					End Select
				End If
			Next
			If f=-1 Then
				'Not found, add it at the end of the section
				Redim Preserve A(UBound(A)+1)
				For x=UBound(A) To j+2 Step -1
					A(x)=A(x-1)
				Next
				A(j+1)=Key & "=" & sValue
			End If
			'Define the content
			s=""
			For x=0 To UBound(A)	
				s=s & A(x) & vbCrLf
			Next
			'Suppress the last CRLF
			If Right(s,2)=vbCrLf Then s=Left(s,Len(s)-2)
			Content=s	'Write it
		End If
	End Property
End Class 


function UDate(oldDate)
  UDate = DateDiff("s", "01/01/1970 00:00:00", oldDate)
end function

function unUDate(intTimeStamp)
  unUDate = DateAdd("s", intTimeStamp, "01/01/1970 00:00:00")
end function


Function EchoOut (strEcho)
	EchoOut = 0
	wscript.echo strEcho
	EchoOut = 1
End Function


Function DebugOut (strEcho)
	DebugOut = 0
	If DebugOutToggle = 1 Then
		MsgBox strEcho
		DebugOut = 1
	End If
End Function


Sub ExitScript
	WriteLog "Ending Script: " & Now
	wscript.quit (0)
End Sub